import { CSSObject, DelegateEventHandler } from './utility';
import { WebCellClass } from './WebCell';
export interface ComponentMeta {
    tagName: `${string}-${string}`;
    extends?: keyof HTMLElementTagNameMap;
    renderTarget?: 'shadowRoot' | 'children';
    style?: string | CSSObject;
}
export declare function component({ style, ...meta }: ComponentMeta): <T extends WebCellClass<import("./utility").WebCellProps, {}>>(Class: T) => T;
export declare function watch(prototype: Object, key: string, meta?: PropertyDescriptor): void;
export declare function attribute({ constructor }: Object, key: string): void;
export interface DOMEventDelegater {
    type: keyof HTMLElementEventMap;
    selector: string;
    method: string;
}
export declare function on(type: DOMEventDelegater['type'], selector: string): <T extends DelegateEventHandler<any>>({ constructor }: Object, method: string, meta: PropertyDescriptor) => PropertyDescriptor & {
    value: T;
};
